#!/usr/bin/env python
import multiprocessing as mp
import pprint
import nmap
import json
import zmq
import time
import sys
import os
import paramiko

from netaddr import IPNetwork

NUM_PROCS = 32

outFile = open('ansible-targets.yaml', 'w+')

def portScan(iqueue, oqueue):
  while True:
    msg = iqueue.get()         # Read from the queue and do nothing
    if msg == 'exit':
      break
    nm = nmap.PortScanner() # instantiate nmap.PortScanner object
    nm.scan(msg, arguments='-p 22') # scan subnet for port 22

    hosts = nm.all_hosts() #return list of hosts/ips that have port 22 open

    for h in hosts:
        #client = paramiko.client.SSHClient()
        #client.set_missing_host_key_policy(paramiko.AutoAddPolicy())
        try: #try to connect to host with ecc-admin along with keys
#            client.connect(h,user,passW)
            #client.connect(h,username="ecc-admin",key_filename='/root/.ssh/authorized_keys')
            oqueue.put(nm[h]) #if it able to connect add it to output queue
        except Exception as e:
            pass

def main():
  pp = pprint.PrettyPrinter(indent=4)
  iqueue = mp.Queue() #input queue
  oqueue = mp.Queue() #output queue
  procs = []


  for i in range(0,NUM_PROCS):
    p = mp.Process(target=portScan, args=((iqueue),oqueue))
    procs.append(p)
    p.start()

  #IP:
  #231: 172.20.195.0/22
  #JT: 134.197.69.0/24
  #321=134.197.40.0/22
  ips = IPNetwork('172.20.195.25')
  [iqueue.put("%s" % ip) for ip in ips]
  [iqueue.put("exit") for i in range(0, NUM_PROCS)]
  for p in procs:
    p.join()
  print(oqueue.empty())
  print("Creating Ansible Invetory File")
  outFile.write('['+sys.argv[1]+']\n')
  while (oqueue.empty() == False):
    h = oqueue.get()
    print(h)
    #g = h['addresses']
    #print(h)
    outFile.write(h['addresses']['ipv4'])
    #uncomment if using hostnames instead of ips
    #outFile.write(g['ipv4']+'.rd.unr.edu')
  outFile.close()
  os.system('stty sane')

if __name__ == "__main__":
  main()
